#pragma once
#include <string>
#include <vector>
#include <chrono>
struct EngineStatistics {
	float frameTime;
	uint32_t verts;
	uint32_t DC;

	int64_t frames;
	int64_t  FPS;

};

class EngineInstrumentation {
public:

	//static int64_t lastSampleTime;

	static uint64_t GetPrecisionTime();
	static void PerfomanceSamplerInit();

	static void Update();
	static void ShowStats();

};

class PerfSampler {
public:

	PerfSampler(const std::string& name);
	~PerfSampler();
	void Stop();
private:
	const std::string& name;
	std::chrono::time_point<std::chrono::high_resolution_clock> startTime;
};